﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace Neurall
{

    /* Neuron- klasa reprezentujaca jeden neuron
    * w tablica wag; x-tablicasygnalow wejsciowych
    * n-ilosc sygnalow wejsciowych)*/

    public class Neuron
    {

        public double[] W;
       public double b;
       public double gamma;
        static int kk = 0;
      
   

         
      


        public Neuron(int n, int bias,double bb,double gama) 
        {
            if (bias == 0)
            {
                W = new double[n];
                int j = 3;
                
                for (int i = 0; i < n; i++) 
                {
                    j++;
                     Random rand = new Random((int)(System.Convert.ToInt32(System.DateTime.UtcNow.Millisecond + j * i + kk )));
                       W[i] = rand.NextDouble();
                    
                      W[i] =W[i] /2.0;
                }
             
                   W[W.Length-1] = -0.7;
                kk++;
            }
            else
            {                       //neuron biasu wagi =0 bo i tak zawsze ma byc -1

                W = new double[n];
                
                for (int i = 0; i < n; i++)
                    W[i] = 0;

            }
            b = bb;
            gamma = gama;
            
         }

        
        
        
        public double Net(double[] inputx) //bias 
        {
            if (inputx.Length != W.Length)
                throw new Exception("wymiar wag i sygnału wejściowego musi byćtaki sam");
            else
            {
              
                double net = 0;
                for (int i = 0; i < W.Length; i++)
                {
                    net += W[i] * inputx[i];
                }
                return net;
            }
        }



        public double DNet(double[] inputx)
        {
            double[] zer = new double[W.Length];

            return    (-inputx[inputx.Length - 1] * W[W.Length - 1] +normm(W,b,gamma)+normm(inputx,b,gamma)-odl(W, inputx,b,gamma));
        
        }


    

     

        static double odl(double[] W, double[] inputx,double b,double gamma) //odleglosc miedzy w a x (jeszcze BEZ normalizacji!!!)
        {
            double g=1 ;
            double bb = 0;
            double dl = 0;
            for (int i = 0; i < inputx.Length - 1; i++)
                dl += Math.Pow(Math.Abs(W[i] - inputx[i]), b);
              if (gamma!= 0)
                  g = 1.0 / gamma;
                
            return  Math.Pow(dl, g);

        }

        static double normm(double[] W, double b,double gamma)
        {
        double g=0;
        double dl = 0;
           for (int i = 0; i < W.Length - 1; i++)
                dl += Math.Pow(Math.Abs(W[i] ), b);
           if (gamma != 0)
               g = 1.0 / gamma;
                
            return  Math.Pow(dl, g);
    }


        public double pochCzesc(double[] input,  int ind )//!! ZMIeni|C potem
        {


            double g = 0;
            double dd = 0;
            double[] zero = new double[W.Length];
            double abwx = 1;
            double znw = 1;
            if (W[ind] < 0)
                znw = -1;
            if (W[ind] < input[ind])
                abwx = -1;
            if (ind == input.Length - 1)
            {
           
                dd = 1 * (-input[ind]);
            }

            else
            {
                if (gamma!= 0)
                {
                    g= (double)1 / gamma;

                    dd =  g*(Math.Pow( Math.Pow(normm(W,b,gamma),gamma),g-1.0))* b*Math.Pow( Math.Abs(W[ind]),b-1.0)*znw -g * (Math.Pow(Math.Pow(odl(W, input, b,gamma), gamma), g - 1.0)) * b * Math.Pow(Math.Abs(W[ind] - input[ind]), b - 1.0) * abwx;
                   
                    
                     
                }
            }
             
                
                    return   dd;

        }


        public double pochB(double[] input)
        {
            
            double g = 1;
            if(gamma!=0)
                g=1.0 / gamma;
            double d1 = 0;
            double d2 = 0;
            for (int i = 0; i < W.Length - 1; i++)
            {
                if (W[i] == 0)
                    W[i] = 0.000000001;
                
                 d1 += Math.Log(Math.Abs(W[i])) * Math.Pow(Math.Abs(W[i]), b);
         

            }
            d2=g* Math.Pow( Math.Pow( normm(W,b,gamma),gamma),g)*d1;
           
            
            double x1 = 0;
            double x2 = 0;
            for (int i = 0; i < input.Length - 1; i++)
            {
                if (input[i] == 0)
                    input[i] = 0.000000001;
                   x1 += Math.Log(Math.Abs(input[i])) * Math.Pow(Math.Abs(input[i]), b);
            

            }
            x2=g* Math.Pow( Math.Pow( normm(input,b,gamma),gamma),g)*x1;
            
            double c1 = 0;
            double c2 = 0;
            for(int i=0;i<input.Length-1;i++)
            {
                if (input[i] == W[i])
                    input[i]+= 0.000000001;
                double c11 = Math.Log(Math.Abs(W[i] - input[i]));
                c1 += c11* Math.Pow(Math.Abs(W[i] - input[i]), b);
               
                 
            }

            c2= g* Math.Pow( Math.Pow( odl(W, input,b,gamma),gamma),g)*c1;
            double ll = d2 - c2 + x2;
            return   d2-c2+x2;
        }




        public double pochGam(double[] input)
        {
            double x1=0;
            double g=1.0/gamma;
             double a1 = Math.Pow(normm(input, b, gamma), g);
             double a2 = Math.Pow(normm(W, b, gamma), g);
            double a3 = Math.Pow(odl(W, input, b, gamma), g);
            if (a2 == 0)
                 a2 += 0.00000001;
             if (a1 == 0)
                  a1 += 0.00000001;
            if (a3 == 0)
                a3 += 0.00000001;
            return  -(1.0 / (gamma * gamma)) *  (normm(input, b, gamma) * Math.Log(a1) + normm(W, b, gamma) * Math.Log(a2) - odl(W,input, b, gamma) * Math.Log(a3));



        }



        public double pochSkal(double[] input)
        {
            
          
            return DNet(input)  ;
        }






        static public double function(double net, double lambda)
        {
            return 1 / (1 + Math.Exp(-lambda * net));
        }

       
        static public double unipolarpoch(double net, double lambda)
        {
            double y = function(net, lambda);
            return lambda*y * (1 - y);

        }

       




        static public double functionNonEuc(double dNet, double lambda)
        {
            return 1 / (1 + Math.Exp(-lambda * dNet));
        }

        static public double unipolarpochNonEuc(double dNet, double lambda) //dodac trzeci argument do reszty pochodnych i go nie uzywac;
        {

            double y = function(dNet, lambda);
            return lambda*y * (1 - y) ;

        }






        static public double function1(double net, double lambda) //przeksztalcam funkcje by zamiast x - a bylo net
        {
           
            if (net < (-lambda))
                return 0;
            else
            {
                if (net >= ( - lambda) && net < 0)
                    return (0.5 + ((net ) * (2 * lambda + net)) / (2 * lambda * lambda));
                else
                {
                    if (net >= 0 && net <=  lambda)
                        return (0.5 + ((net) * (2 * lambda - net )) / (2 * lambda * lambda));
                    else return 1;
                }
            }

        }




        static public double poch1(double net, double lambda)
        {
                
            if ( net < ( - lambda))
                return 0;
            else
            {
                if ( net >= ( - lambda) &&  net < 0)
                    return (lambda + net ) / (lambda * lambda);
                else
                {
                    if ( net >= 0 && net <=  lambda)
                        return  (lambda - net ) / (lambda * lambda);
                    else return 0;
                }
            }

        }



        static public double function1Non(double net, double lambda) //przeksztalcam funkcje by zamiast x - a bylo net
        {
            
            if (net < (-lambda))
                return 0;
            else
            {
                if (net >= (-lambda) && net < 0)
                    return (0.5 + ((net) * (2 * lambda + net)) / (2 * lambda * lambda));
                else
                {
                    if (net >= 0 && net <= lambda)
                        return (0.5 + ((net) * (2 * lambda - net)) / (2 * lambda * lambda));
                    else return 1;
                }
            }

        }

        static public double poch1Non(double net, double lambda) //-,2 0,04
        {
            
            if (net < (-lambda))
                return 0;
            else
            {
                if (net >= (-lambda) && net < 0)
                    return (lambda + net) / (lambda * lambda);
                else
                {
                    if (net >= 0 && net <= lambda)
                        return (lambda - net) / (lambda * lambda);
                    else return 0;
                }
            }

        }








        static public double function2(double net, double b)
        {
            return Math.Log(((1 + Math.Exp(1  * net + b)) / (1 + Math.Exp(1 * net - b)))) / (2 * b);  
        }


        static public double function2Non(double net, double b)
        {
            
            return Math.Log(((1 + Math.Exp(-net + b)) / (1 + Math.Exp(-net - b))), Math.E);
        }


        static public double poch2(double net, double b)
        {
            double b1 = Math.Exp( 1   *   net - b);
            double b2 = Math.Exp(1 * net + b);
          
            return 1  * (0.5 * ((b2 / (1 + b1)) - (1 + b2) * b1 / ((1 + b1) * (1 + b1))) / (1 + b2)) * (1 + b1) / (b);
           
        }

     


       


    }
}
